﻿
init python:
    class higher_or_lower_class:
        def __init__(self, name, cards = []):
            self.name = name
            self.cards = cards
            self.deck = self.cards.copy()
            self.played = []
            self.current = None
            self.bet = 10
            self.stage = "Start"
            self.current_bet = 0
        def next(self, stage):
            self.stage = stage
        def guess(self, guess, player):
            current = self.current.number
            last = self.played[-1].number
            if current == 1:
                current = 14
            if last == 1:
                last = 14
            if guess == "high":
                if current > last:
                    self.stage = "Correct"
                    player.cash += self.bet*2
                else:
                    self.stage = "Wrong"

            elif guess == "low":
                if current < last:
                    self.stage = "Correct"
                    player.cash += self.bet*2
                else:
                    self.stage = "Wrong"
        def move(self):
            tag = self.current.suit + str(self.current.number)
            renpy.show_screen("higher_or_lower_card", c = self.current, tag = tag, _tag = tag)
            self.played.append(self.current)
            self.current = None

            for i in self.played:
                if i.x > -1200:
                    i.x -= 350
                    i.rotation = renpy.random.randint(-4, 4)
            if len(self.played) > 10:
                c = self.played.pop(0)
                renpy.hide_screen(c.suit + str(c.number))
        def move_end(self):
            for i in self.played:
                if i.x > -1200:
                    i.x -= 350
                    i.rotation = renpy.random.randint(-4, 4)
            if len(self.played) > 10:
                c = self.played.pop(0)
                renpy.hide_screen(c.suit + str(c.number))
        def bet_in(self, player):
            if player.cash >= self.bet:
                player.cash -= self.bet
                self.current_bet = self.bet
            else:
                self.bet = player.cash
                self.current_bet = self.bet
                player.cash = 0
        def change_bet(self, amount, player):
            self.bet += amount
            if self.bet < 0:
                self.bet = 0
            if self.bet > player.cash:
                self.bet = player.cash
        def deal(self):
            self.current = self.deck.pop(0)
            self.current.rotation = renpy.random.randint(-4, 4)
        def shuffle(self):
            renpy.random.shuffle(self.deck)

        def reset(self):
            self.deck = self.cards.copy()
            for i in self.deck:
                i.x = 0
            for i in range(10):
                renpy.hide_screen("higher_or_lower_card")
            self.played = []
            self.shuffle()
            self.stage = "First deal"

        def end(self):
            self.reset()
            renpy.hide_screen("higher_or_lower")
            return 1
            
default higher_or_lower_ins = higher_or_lower_class("Higher or Lower", all_cards)

transform higher_or_lower_ani(x = 0, r = 0):
    rotate_pad False
    ease renpy.random.randint(5, 10)*.1 xoffset x rotate r

transform higher_or_lower_rot(r):
    rotate_pad False
    ease renpy.random.randint(5, 10)*.1 rotate r

transform higher_or_lower_deal(r = renpy.random.randint(-4, 4)):
    rotate_pad False
    anchor (.5,.5)
    rotate renpy.random.randint(200, 400)
    yoffset -500
    ease renpy.random.randint(5, 10)*.1 rotate r yoffset 0

screen higher_or_lower_card(c, tag):
    style_prefix "cards"
    add "cards/{}/{}.png".format(c.suit, c.number) align .94,.5 at higher_or_lower_ani(c.x, c.rotation)

screen higher_or_lower(p = c_player, g = higher_or_lower_ins):
    modal True
    style_prefix "cards"

    # deck
    if len(g.deck) > 1:
        add "cards/back.png" at higher_or_lower_rot(-3) align 1.0,-0.3 xoffset -40
    if len(g.deck):
        add "cards/back.png" at higher_or_lower_rot(6) align 1.0,-0.3 xoffset -40

    if g.current:
        add "cards/back.png" at higher_or_lower_deal(g.current.rotation) align .87,.5

    if g.stage == "First deal":
        timer .01 action Function(g.deal)
        timer .7 action Function(g.move)
        timer .7 action Function(g.next, "Bet")
    elif g.stage == "Bet":
        timer .01 action Function(g.bet_in, p)
        timer .2 action Function(g.next, "Deal")
    elif g.stage == "Deal":
        timer .01 action Function(g.deal)
        timer .2 action Function(g.next, "Guess")
    elif g.stage == "Guess":
        frame:
            xalign .902 
            vbox:
                button:
                    text _("Higher.")
                    action Function(g.guess, "high", p)
                text _("Guess!")
                button:
                    text _("Lower.")
                    action Function(g.guess, "low", p) 
    elif g.stage == "Correct":
        timer .1 action Function(g.move)
        if len(g.deck):
            timer 1 action Function(g.next, "Bet")
        else:
            timer 1 action Function(g.next, "end")
        frame:
            yalign .8
            vbox:
                text _("Hmm... Lucky guess?")
    elif g.stage == "Wrong":
        timer .1 action Function(g.move)
        if len(g.deck):
            timer 1 action Function(g.next, "Bet")
        else:
            timer 1 action Function(g.next, "end")
        frame:
            yalign .8
            vbox:
                text _("Hahahahaha... Better luck next time")

    if p.cash < 1:
        timer .5 repeat True action Function(g.move_end)
        button:
            background None
            action NullAction()
        frame:
            vbox:
                text _("Looks like you've ran out of money.\nhopefully we will see you again when you have money again.")
                hbox:
                     button:
                        text _("Alright.")
                        action Function(g.end)

    if g.stage == "Start":
        timer .01 action Function(g.shuffle)
        frame:
            vbox:
                text _("Are you ready to play?") + g.name + "?"
                hbox:
                    button:
                        text _("Let's dance!")
                        action Function(g.next, "First deal")
                    button:
                        text _("What is ") + g.name + "?"
                        action ToggleScreen("higher_or_lower_help")
    elif g.stage == "end":
        timer .5 repeat True action Function(g.move_end)
        frame:
            vbox:
                text _("Good game, Do you want to play again?") + g.name + "?"
                hbox:
                    button:
                        text _("Sure!")
                        action Function(g.reset)
                    button:
                        text _("Nah, I have to go.")
                        action Function(g.end)
    else:
        frame:
            yalign 1.0 yoffset -20
            vbox:
                hbox:
                    button:
                        text "-100"
                        action Function(g.change_bet, -100, p)
                    button:
                        text "-10"
                        action Function(g.change_bet, -10, p)
                    button:
                        text "-1"
                        action Function(g.change_bet, -1, p)
                    text str(g.bet)
                    button:
                        text "+1"
                        action Function(g.change_bet, 1, p)
                    button:
                        text "+10"
                        action Function(g.change_bet, 10, p)
                    button:
                        text "+100"
                        action Function(g.change_bet, 100, p)

                text _("You have [p.cash] dollars.")

screen higher_or_lower_help:
    style_prefix "cards"
    button:
        background None
        action Hide("higher_or_lower_help")
    frame:
        xsize 1200
        vbox:
            text _("Cards are drawn one by one and you'll have to guess if the current card would be higher or lower than the last one.") size 30
            text _("Bet wisely and don't lose everything at once. We love to see you try.")

style KGUI:
    align(.5,.5)
    padding(20,20)
    spacing 10
    # color "#fff"
    size 30

    background "#5b371599"
    idle_background "#5b3715bb"
    hover_background "#5b3715ee"


style cards_button is KGUI
style cards_frame is KGUI
style cards_text is KGUI
style cards_vbox is KGUI
style cards_hbox is KGUI
style cards_transform is KGUI








